diff -uNrd ircd-hybrid-6.0/include/client.h ircd-pi1.0a/include/client.h
--- ircd-hybrid-6.0/include/client.h	Fri Dec  1 01:28:46 2000
+++ ircd-pi1.0a/include/client.h	Thu May 23 13:51:47 2002
@@ -17,7 +17,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: client.h,v 1.45 2000/12/01 06:28:46 lusky Exp $
+ * $Id: client.h,v 1.8 2002/05/23 17:51:47 smoli Exp $
  */
 #ifndef INCLUDED_client_h
 #define INCLUDED_client_h
@@ -47,6 +47,11 @@
 #ifndef INCLUDED_dbuf_h
 #include "dbuf.h"
 #endif
+#include "setup.h"
+
+#if defined(HAVE_SSL) && !defined(S_ZIP)
+#include <openssl/ssl.h>
+#endif
 
 #define HOSTIPLEN       16      /* Length of dotted quad form of IP        */
                                 /* - Dianora                               */
@@ -77,6 +82,8 @@
   struct SLink*  invited;       /* chain of invite pointer blocks */
   char*          away;          /* pointer to away message */
   time_t         last;
+  time_t         last_sent;
+  int            spoofed;       /* spoofed hostname */
   int            refcnt;        /* Number of times this block is referenced */
   int            joined;        /* number of channels joined */
   char           id[IDLEN + 1]; /* for future use *hint* */
@@ -102,6 +109,9 @@
   struct ConfItem* nline;       /* N-line pointer for this server */
   struct Client*   servers;     /* Servers on this server */
   struct Client*   users;       /* Users on this server */
+#ifdef HAVE_SSL
+  int              is_ssl;
+#endif
 };
 
 struct Client
@@ -254,6 +264,21 @@
    */
   char              passwd[PASSWDLEN + 1];
   int               caps;       /* capabilities bit-field */
+#ifdef HAVE_SSL
+#ifndef S_ZIP
+  SSL              *ssl;
+  struct X509      *cert;               /* client certificate */
+#else
+  void             *ssl;
+  void             *cert;
+#endif
+  int              read_blocked_on_write;
+  int              read_blocked;
+  int              write_blocked_on_read;
+  int              write_blocked;
+  int              ssl_isconnecting;
+  int              verify_ok;
+#endif /* HAVE_SSL */
 };
 
 /*
@@ -266,7 +291,6 @@
 #define STAT_SERVER     0x10   /* 0  */
 #define STAT_CLIENT     0x20   /* 1  */
 
-
 #define IsRegisteredUser(x)     ((x)->status == STAT_CLIENT)
 #define IsRegistered(x)         ((x)->status  > STAT_UNKNOWN)
 #define IsConnecting(x)         ((x)->status == STAT_CONNECTING)
@@ -313,24 +337,27 @@
 #define FLAGS_NORMALEX     0x0400 /* Client exited normally */
 #define FLAGS_SENDQEX      0x0800 /* Sendq exceeded */
 #define FLAGS_IPHASH       0x1000 /* iphashed this client */
+#define FLAGS_SSL          0x2000 /* connection uses SSL */
 
 /* umodes, settable flags */
-#define FLAGS_SERVNOTICE   0x0001 /* server notices such as kill */
-#define FLAGS_CCONN        0x0002 /* Client Connections */
-#define FLAGS_REJ          0x0004 /* Bot Rejections */
-#define FLAGS_SKILL        0x0008 /* Server Killed */
-#define FLAGS_FULL         0x0010 /* Full messages */
-#define FLAGS_SPY          0x0020 /* see STATS / LINKS */
-#define FLAGS_DEBUG        0x0040 /* 'debugging' info */
-#define FLAGS_NCHANGE      0x0080 /* Nick change notice */
-#define FLAGS_WALLOP       0x0100 /* send wallops to them */
-#define FLAGS_OPERWALL     0x0200 /* Operwalls */
-#define FLAGS_INVISIBLE    0x0400 /* makes user invisible */
-#define FLAGS_BOTS         0x0800 /* shows bots */
-#define FLAGS_EXTERNAL     0x1000 /* show servers introduced */
+#define FLAGS_SERVNOTICE   0x00000001 /* server notices such as kill */
+#define FLAGS_CCONN        0x00000002 /* Client Connections */
+#define FLAGS_REJ          0x00000004 /* Bot Rejections */
+#define FLAGS_SKILL        0x00000008 /* Server Killed */
+#define FLAGS_FULL         0x00000010 /* Full messages */
+#define FLAGS_SPY          0x00000020 /* see STATS / LINKS */
+#define FLAGS_DEBUG        0x00000040 /* 'debugging' info */
+#define FLAGS_NCHANGE      0x00000080 /* Nick change notice */
+#define FLAGS_WALLOP       0x00000100 /* send wallops to them */
+#define FLAGS_OPERWALL     0x00000200 /* Operwalls */
+#define FLAGS_INVISIBLE    0x00000400 /* makes user invisible */
+#define FLAGS_BOTS         0x00000800 /* shows bots */
+#define FLAGS_EXTERNAL     0x00001000 /* show servers introduced */
 /* user information flags, only settable by remote mode or local oper */
-#define FLAGS_OPER         0x4000 /* Operator */
-#define FLAGS_LOCOP        0x8000 /* Local operator -- SRB */
+#define FLAGS_OPER         0x00004000 /* Operator */
+#define FLAGS_LOCOP        0x00008000 /* Local operator -- SRB */
+#define FLAGS_ENFORCE      0x00010000 /* Can enforce everything -shifty  rel. pi-0.1 */
+#define FLAGS_SSLU         0x00020000 /* user connects via SSL */
 
 /* *sigh* overflow flags */
 #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
@@ -349,6 +376,7 @@
 #define FLAGS2_OPER_K           0x0400  /* oper can kill/kline */
 #define FLAGS2_OPER_DIE         0x0800  /* oper can die */
 #define FLAGS2_OPER_REHASH      0x1000  /* oper can rehash */
+#define FLAGS2_OPER_ENFORCE     0x2000  /* oper can enforce -shifty  rel. pi-0.1 */
 #define FLAGS2_OPER_FLAGS       (FLAGS2_OPER_GLOBAL_KILL | \
                                  FLAGS2_OPER_REMOTE | \
                                  FLAGS2_OPER_UNKLINE | \
@@ -356,7 +384,9 @@
                                  FLAGS2_OPER_N | \
                                  FLAGS2_OPER_K | \
                                  FLAGS2_OPER_DIE | \
-                                 FLAGS2_OPER_REHASH)
+                                 FLAGS2_OPER_REHASH | \
+                                 FLAGS2_OPER_ENFORCE)
+
 /* ZIP_LINKS */
 
 #define FLAGS2_ZIP           0x4000  /* (server) link is zipped */
@@ -374,15 +404,16 @@
 #define FLAGS2_SENDQ_POP  0x400000  /* sendq exceeded (during list) */
 
 
-#define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP)
+#define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | FLAGS_SSLU | FLAGS_ENFORCE)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
-                      FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOP )
-
+                      FLAGS_BOTS | FLAGS_EXTERNAL | \
+                      FLAGS_LOCOP | FLAGS_ENFORCE | FLAGS_SSLU)
 #ifndef OPER_UMODES
 #define OPER_UMODES  (FLAGS_OPER | FLAGS_WALLOP | FLAGS_SERVNOTICE | \
-                      FLAGS_SPY | FLAGS_OPERWALL | FLAGS_DEBUG | FLAGS_BOTS)
+                      FLAGS_SPY | FLAGS_OPERWALL | FLAGS_DEBUG | \
+                      FLAGS_BOTS | FLAGS_ENFORCE) /* -shifty  rel. pi-0.1 */
 #endif /* OPER_UMODES */
 
 #ifndef LOCOP_UMODES
@@ -405,6 +436,13 @@
 #define MyConnect(x)            ((x)->local_flag != 0)
 #define MyClient(x)             (MyConnect(x) && IsClient(x))
 
+#ifdef HAVE_SSL
+#define IsSSL(x)                ((x)->flags & FLAGS_SSL)
+#define SetSSL(x)               ((x)->flags |= FLAGS_SSL)
+#define IsSSLServ(x)            ((x)->serv->is_ssl)
+#define SetSSLServ(x)           ((x)->serv->is_ssl = 1)
+#endif
+
 /* oper flags */
 #define MyOper(x)               (MyConnect(x) && IsOper(x))
 #define IsOper(x)               ((x)->umodes & FLAGS_OPER)
@@ -422,6 +460,7 @@
 #define ClearInvisible(x)       ((x)->umodes &= ~FLAGS_INVISIBLE)
 #define SendWallops(x)          (((x)->umodes & FLAGS_WALLOP) && IsAnOper(x))
 #define ClearWallops(x)         ((x)->umodes &= ~FLAGS_WALLOP)
+#define SendNotice(x)		((x)->umodes & FLAGS_SERVNOTICE)
 #define SendServNotice(x)       (((x)->umodes & FLAGS_SERVNOTICE) && IsAnOper(x))
 #define SendOperwall(x)         ((x)->umodes & FLAGS_OPERWALL)
 #define SendCConnNotice(x)      ((x)->umodes & FLAGS_CCONN)
@@ -432,7 +471,10 @@
 #define SendDebugNotice(x)      ((x)->umodes & FLAGS_DEBUG)
 #define SendNickChange(x)       ((x)->umodes & FLAGS_NCHANGE)
 #define SetWallops(x)           ((x)->umodes |= FLAGS_WALLOP)
-
+#define SetEnforce(x)           ((x)->umodes |= FLAGS_ENFORCE)
+#define IsEnforce(x)            ((x)->umodes & FLAGS_ENFORCE)
+#define SetSSLUmode(x)          ((x)->umodes |= FLAGS_SSLU)
+#define IsSSLUmode(x)           ((x)->umodes & FLAGS_SSLU)
 
 #ifdef REJECT_HOLD
 #define IsRejectHeld(x)         ((x)->flags & FLAGS_REJECT_HOLD)
@@ -495,6 +537,8 @@
 #define SetOperRehash(x)        ((x)->flags2 |= FLAGS2_OPER_REHASH)
 #define IsOperRehash(x)         ((x)->flags2 & FLAGS2_OPER_REHASH)
 #define CBurst(x)               ((x)->flags2 & FLAGS2_CBURST)
+#define SetOperEnforce(x)       ((x)->flags2 |= FLAGS2_OPER_ENFORCE)
+#define IsOperEnforce(x)        ((x)->flags2 & FLAGS2_OPER_ENFORCE)
 
 /*
  * 'offsetof' is defined in ANSI-C. The following definition
diff -uNrd ircd-hybrid-6.0/include/common.h ircd-pi1.0a/include/common.h
--- ircd-hybrid-6.0/include/common.h	Fri Jul 30 02:48:10 1999
+++ ircd-pi1.0a/include/common.h	Fri Nov  2 19:23:18 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: common.h,v 1.15 1999/07/30 06:48:10 tomh Exp $
+ * $Id: common.h,v 1.1.1.1 2001/11/03 00:23:18 shifty Exp $
  */
 #ifndef INCLUDED_common_h
 #define INCLUDED_common_h
diff -uNrd ircd-hybrid-6.0/include/config.h ircd-pi1.0a/include/config.h
--- ircd-hybrid-6.0/include/config.h	Sun Nov 26 23:11:47 2000
+++ ircd-pi1.0a/include/config.h	Thu May 23 13:51:47 2002
@@ -1,5 +1,5 @@
 /************************************************************************
- *   IRC - Internet Relay Chat, include/config.h
+ *   IRC - Internet Relay Chat, include/leaf.h
  *   Copyright (C) 1990 Jarkko Oikarinen
  *
  *   This program is free software; you can redistribute it and/or modify
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: config.h,v 1.90 2000/11/27 04:11:47 lusky Exp $
+ * $Id: config.h,v 1.13 2002/05/23 17:51:47 smoli Exp $
  */
 #ifndef INCLUDED_config_h
 #define INCLUDED_config_h
@@ -51,21 +51,31 @@
  * system limits. If you know what you are doing, increase them now
  */
 
-#define HARD_FDLIMIT_   256
-#define INIT_MAXCLIENTS 200
+#ifndef HUB
+
+#define HARD_FDLIMIT_   1024
+#define INIT_MAXCLIENTS  800
+
+#else
+
+#define HARD_FDLIMIT_   128
+#define INIT_MAXCLIENTS  80
+
+#endif
 
 #if defined(__CYGWIN__)
 #undef HARD_FDLIMIT_
-#define HARD_FDLIMIT_   25
+#define HARD_FDLIMIT_   512
 #undef INIT_MAXCLIENTS
-#define INIT_MAXCLIENTS 20
+#define INIT_MAXCLIENTS 500
 #endif /* __CYGWIN__ */
 
+
 /*
  * This is how many 'buffer connections' we allow... 
  * Remember, MAX_BUFFER + MAX_CLIENTS can't exceed HARD_FDLIMIT :)
  */
-#define MAX_BUFFER      60
+#define MAX_BUFFER      25
 
 /* NICKNAMEHISTORYLENGTH - size of WHOWAS array
  * this defines the length of the nickname history.  each time a user changes
@@ -75,13 +85,26 @@
  *       will be preallocated for the entire whowas array when ircd is started.
  *       You will want to crank this down if you are on a small net.
  */
+#ifndef HUB
 #define NICKNAMEHISTORYLENGTH 15000
+#else
+#define NICKNAMEHISTORYLENGTH 15
+#endif
 
 /* Don't change this... */
 #define HARD_FDLIMIT    (HARD_FDLIMIT_ - 10)
 #define MASTER_MAX      (HARD_FDLIMIT - MAX_BUFFER)
 /*******************************************************************/
 
+/* CHROOTDIR - chroot() before reading conf
+ * Define for value added security if you are paranoid.
+ * All files you access must be in the directory you define as DPATH.
+ * (This may effect the PATH locations above, though you can symlink it)
+ *
+ * You may want to define IRC_UID and IRC_GID
+ */
+#define CHROOTDIR
+
 /* DPATH SPATH CPATH MPATH KPATH - directoy and files locations
  * Full pathnames and defaults of irc system's support files. Please note that
  * these are only the recommended names and paths. Change as needed.
@@ -107,8 +130,12 @@
  *
  */
 
-#define DPATH   "/usr/local/ircd/"
-#define SPATH   "/usr/local/ircd/ircd"
+#define DPATH   IRCDDIR "/"
+#ifdef CHROOTDIR
+#define SPATH   "ircd"
+#else
+#define SPATH   DPATH    "ircd"
+#endif
 #define CPATH   "ircd.conf"
 #define KPATH   "kline.conf"
 #define DLPATH  "kline.conf"
@@ -117,12 +144,15 @@
 #define PPATH   "ircd.pid"
 #define HPATH   "opers.txt"
 #define OPATH   "opers.motd"
+#define CEPATH  "ircd.pem"
+#define RNPATH  "ircd.rnd"
+#define CAPATH  "ca.crt"
 
 /* HIDE_OPS
  * Define this to prevent non chanops from seeing what ops a channel has
  * NOT ADEQUATELY TESTED YET, DON'T USE ON PRODUCTION NETWORK --Rodder
  */
-/* #undef HIDE_OPS */
+#undef HIDE_OPS
 
 /* SERVERHIDE
  * Define this to prevent users from seeing what server a user is on.
@@ -130,17 +160,17 @@
  * TRACE and LTRACE, and prevents hunting by nickname for nonopers.
  * NOT ADEQUATELY TESTED YET, DON'T USE ON PRODUCTION NETWORK --Rodder
  */
-/* #undef SERVERHIDE */
+#undef SERVERHIDE
 
 /* NETWORK_NAME
  * Displayed in place of the servername when SERVERHIDE is enabled
  */   
-#define NETWORK_NAME "EFnet"
+#define NETWORK_NAME "Pi-IRC"
 
 /* NETWORK_DESC
  * Displayed in place of the server info when SERVERHIDE is enabled
  */
-#define NETWORK_DESC "Eris Free Network"
+#define NETWORK_DESC "Political incorrect"
 
 
 /* TS_MAX_DELTA and TS_WARN_DELTA -  allowed delta for TS when another
@@ -185,8 +215,10 @@
  *
  * These need to be defined if you want to use SYSLOG logging, too.
  */
-#define FNAME_USERLOG "/usr/local/ircd/users" /* */
-#define FNAME_OPERLOG "/usr/local/ircd/opers" /* */
+#ifdef HUB
+#define FNAME_USERLOG "users.log"
+#endif
+#define FNAME_OPERLOG "opers.log"
 
 /* RFC1035_ANAL
  * Defining this causes ircd to reject hostnames with non-compliant chars.
@@ -198,20 +230,20 @@
  * Defining this will allow periods in ident replies.  Use of this is
  * strongly discouraged on public networks
  */
-#undef ALLOW_DOT_IN_IDENT
+#define ALLOW_DOT_IN_IDENT
 
 /* MAX_MULTI_MESSAGES
  * Maximum number of recipients to a PRIVMSG.  Any more than MAX_MULTI_MESSAGES
  * will not be sent.  If MAX_MULTI_MESSAGES is 1, then any PRIVMSG with a ',' in
  * the target will be rejected
  */
-#define MAX_MULTI_MESSAGES 2
+#define MAX_MULTI_MESSAGES 1
 
 /* NO_DUPE_MULTI_MESSAGES
  * Define this to check for duplicate recipients in PRIVMSG, at the expense
  * of noticeable CPU cycles.
  */
-#define NO_DUPE_MULTI_MESSAGES
+#undef NO_DUPE_MULTI_MESSAGES
 
 /* WARN_NO_NLINE
  * Define this if you want ops to get noticed about "things" trying to
@@ -227,7 +259,7 @@
  * or if you wish to customize the  messages, define this.
  * Otherwise leave it undef'd for plain ole boring messages.
  */
-#undef CUSTOM_ERR
+#define CUSTOM_ERR
 
 /* FAILED_OPER_NOTICE - send a notice to all opers when someone
  * tries to /oper and uses an incorrect password.
@@ -237,7 +269,7 @@
 /* SHOW_FAILED_OPER_ID - if FAILED_OPER_NOTICE is defined, also notify when
  * a client fails to oper because of a identity mismatch (wrong host or nick)
  */
-#undef SHOW_FAILED_OPER_ID
+#define SHOW_FAILED_OPER_ID
 
 /* SHOW_FAILED_OPER_PASSWD - if FAILED_OPER_NOTICE is defined, also show the
  * attempted passwd
@@ -297,7 +329,7 @@
  * from harassing the IRCops.
  * However, the client will still see the real reason upon connect attempts.
  */
-#define KLINE_WITH_CONNECTION_CLOSED
+#undef KLINE_WITH_CONNECTION_CLOSED
 
 /* NON_REDUNDANT_KLINES - If you want the server to flag and not apply
  * redundant klines
@@ -325,7 +357,7 @@
 /* SPOOF_NOTICE - See a notice when a user connects with a
  * spoofed I: line
  */
-#define SPOOF_NOTICE
+#undef SPOOF_NOTICE
 
 /* STATS_NOTICE - See a notice when a user does a /stats
  *
@@ -352,19 +384,23 @@
  */
 #define NO_WHOIS_WILDCARDS
 
+#define PACE_TRACE
+#define PACE_WALLOPS
+#define PACE_CERT
+
 /* PACE_WAIT - minimum seconds between use of MOTD, INFO, HELP, LINKS, TRACE
  * -Dianora
  */
-#define PACE_WAIT 10
+#define PACE_WAIT 3
 
-/* KNOCK_DELAY 5 minutes per each KNOCK should be enough
+/* KNOCK_DELAY 2 minutes per each KNOCK should be enough
  */
-#define KNOCK_DELAY 300
+#define KNOCK_DELAY 120
 
 /* If you are an admin that does not think operwall/wallops
  * should be used instead of a channel, define this.
  */
-#define PACE_WALLOPS
+#undef PACE_WALLOPS
 #define WALLOPS_WAIT 10 
 
 /* SHORT_MOTD
@@ -407,7 +443,7 @@
  * These can be over-ridden in ircd.conf file, with flags in last O field
  */
 #define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL)
-#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE)
+#define LOCOP_UMODES  (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE)
 
 /* MAXIMUM LINKS - max links for class 0 if no Y: line configured
  *
@@ -438,26 +474,22 @@
  */
 #define MAXIMUM_LINKS 1
 
-/* HUB - enable server-server routing
- * If your server is running as a a HUB Server then define this.
- * A HUB Server has many servers connect to it at the same as opposed
- * to a leaf which just has 1 server (typically the uplink). Define this
- * correctly for performance reasons.
- */
-#undef  HUB
-
 /* CMDLINE_CONFIG - allow conf-file to be specified on command line
  * NOTE: defining CMDLINE_CONFIG and installing ircd SUID or SGID is a MAJOR
  * security problem - they can use the "-f" option to read any files
  * that the 'new' access lets them.
  */
-#define CMDLINE_CONFIG
+#undef CMDLINE_CONFIG
 
 /* INIT_LOG_LEVEL - what level of information is logged to ircd.log
  * options are:
  *   L_CRIT, L_ERROR, L_WARN, L_NOTICE, L_TRACE, L_INFO, L_DEBUG
  */
+#ifdef DEBUG
+#define INIT_LOG_LEVEL L_DEBUG
+#else
 #define INIT_LOG_LEVEL L_NOTICE
+#endif
 
 /* USE_LOGFILE - log errors and such to LPATH
  * If you wish to have the server send 'vital' messages about server
@@ -529,17 +561,17 @@
 /* IRC_UID IRC_GID - user and group id ircd should switch to if run as root
  * If you start the server as root but wish to have it run as another user,
  * define IRC_UID to that UID.  This should only be defined if you are running
- * as root and even then perhaps not.
+ * as root and even then perhaps not. - obsolete
  */
-#define IRC_UID 1001
-#define IRC_GID 31
+/*#define IRC_UID 1000
+#define IRC_GID 100*/
 
 /* CLIENT_FLOOD - client excess flood threshold
  * this controls the number of bytes the server will allow a client to
  * send to the server without processing before disconnecting the client for
  * flooding it.  Values greater than 8000 make no difference to the server.
  */
-#define CLIENT_FLOOD    2560
+#define CLIENT_FLOOD    2048
 
 /* NOISY_HTM - should HTM be noisy by default
  * should be YES or NO
@@ -551,7 +583,7 @@
  * clients with a little i instead of an I in their I line
  * can be chanopped, but cannot chanop anyone else.
  */
-#define LITTLE_I_LINES
+#undef LITTLE_I_LINES
 
 /*
  * define ONE of NO_CHANOPS_ON_SPLIT, NO_JOIN_ON_SPLIT
@@ -565,7 +597,7 @@
  * if there are no servers presently connected to this server
  * opers are not affected. 
  */
-#undef NO_CHANOPS_WHEN_SPLIT
+#define NO_CHANOPS_WHEN_SPLIT
 
 /* 
  * NO_JOIN_ON_SPLIT_SIMPLE
@@ -599,7 +631,11 @@
  * the net. for a leaf, 2 is fine. If the number of servers seen
  * on the net gets less than 2, a split is deemed to have happened.
  */
+#ifndef HUB
 #define SPLIT_SMALLNET_SIZE 2
+#else
+#define SPLIT_SMALLNET_SIZE 3
+#endif
 
 /*
  * SPLIT_SMALLNET_USER_SIZE defines how many global users on the
@@ -609,7 +645,7 @@
  * number of users seen on net > SPLIT_SMALLNET_USER_SIZE start
  * counting down the SERVER_SPLIT_RECOVERY_TIME
  */
-#define SPLIT_SMALLNET_USER_SIZE 10000
+#define SPLIT_SMALLNET_USER_SIZE 25
 
 /*
  * SPLIT_PONG will send a PING to a server after the connect burst.
@@ -670,7 +706,7 @@
  * client was compiled with QUIT_ON_OPERATOR_KILL which was mandatory policy
  * on UMich.Edu hosts.
  */
-#define SEND_FAKE_KILL_TO_CLIENT
+#undef SEND_FAKE_KILL_TO_CLIENT
  
 /*
  * Limited Trace - Reports only link and oper traces even when O:line is
@@ -943,22 +979,17 @@
  * to make your client server very sluggish.
  * You usually shouldn't need this. -Dianora
 */
-#undef DEBUGMODE               /* define DEBUGMODE to enable debugging mode.*/
-
-/*
- * viconf option, if USE_RCS is defined, viconf will use rcs "ci"
- * to keep the conf file  under RCS control.
- */
-#define USE_RCS
+#ifdef DEBUG
+#define DEBUGMODE               /* define DEBUGMODE to enable debugging mode.*/
+#endif
 
-/* ----------------- not approved on EFnet section -------------------- */
 /* GLINES - global Kline-like bans
  * Define this if you want GLINE support
  * when this is defined, 3 completely different opers from
  * three different servers must do the identical GLINE in order
  * for the G line to take effect.
  */
-#undef GLINES
+#define GLINES
 #define GLINEFILE       "gline.log"
 
 /* GLINE_TIME - local expire time for GLINES
@@ -984,14 +1015,8 @@
  * if you still have a machine with this bug, it doesn't belong on EFnet
  */
 
-/* CHROOTDIR - chroot() before reading conf
- * Define for value added security if you are paranoid.
- * All files you access must be in the directory you define as DPATH.
- * (This may effect the PATH locations above, though you can symlink it)
- *
- * You may want to define IRC_UID and IRC_GID
- */
-#undef CHROOTDIR
+/* SPOOF_FREEFORM */
+#define SPOOF_FREEFORM
 
 /* ------------------------- END CONFIGURATION SECTION -------------------- */
 #define MAX_CLIENTS INIT_MAXCLIENTS
diff -uNrd ircd-hybrid-6.0/include/dbuf.h ircd-pi1.0a/include/dbuf.h
--- ircd-hybrid-6.0/include/dbuf.h	Sat Sep  4 16:21:08 1999
+++ ircd-pi1.0a/include/dbuf.h	Fri Nov  2 19:23:21 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
-/* $Id: dbuf.h,v 1.6 1999/09/04 20:21:08 lusky Exp $ */
+/* $Id: dbuf.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $ */
 #ifndef INCLUDED_dbuf_h
 #define INCLUDED_dbuf_h
 #ifndef INCLUDED_config_h
diff -uNrd ircd-hybrid-6.0/include/dline_conf.h ircd-pi1.0a/include/dline_conf.h
--- ircd-hybrid-6.0/include/dline_conf.h	Thu Oct  5 23:00:56 2000
+++ ircd-pi1.0a/include/dline_conf.h	Fri Nov  2 19:23:21 2001
@@ -1,6 +1,6 @@
 /* dline_conf.h  -- lets muse over dlines, shall we?
  *
- * $Id: dline_conf.h,v 1.4 2000/10/06 03:00:56 lusky Exp $ 
+ * $Id: dline_conf.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $ 
  */
 
 #ifndef INCLUDED_dline_conf_h
diff -uNrd ircd-hybrid-6.0/include/fdlist.h ircd-pi1.0a/include/fdlist.h
--- ircd-hybrid-6.0/include/fdlist.h	Sat Jul 24 03:54:00 1999
+++ ircd-pi1.0a/include/fdlist.h	Fri Nov  2 19:23:21 2001
@@ -1,7 +1,7 @@
 /*
  * fdlist.h
  *
- * $Id: fdlist.h,v 1.10 1999/07/24 07:54:00 tomh Exp $
+ * $Id: fdlist.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $
  */
 #ifndef INCLUDED_fdlist_h
 #define INCLUDED_fdlist_h
diff -uNrd ircd-hybrid-6.0/include/fileio.h ircd-pi1.0a/include/fileio.h
--- ircd-hybrid-6.0/include/fileio.h	Tue Jul 13 01:58:53 1999
+++ ircd-pi1.0a/include/fileio.h	Fri Nov  2 19:23:21 2001
@@ -16,7 +16,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: fileio.h,v 1.2 1999/07/13 05:58:53 tomh Exp $
+ * $Id: fileio.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $
  */
 #ifndef INCLUDED_fileio_h
 #define INCLUDED_fileio_h
diff -uNrd ircd-hybrid-6.0/include/flud.h ircd-pi1.0a/include/flud.h
--- ircd-hybrid-6.0/include/flud.h	Thu Oct  5 23:00:56 2000
+++ ircd-pi1.0a/include/flud.h	Fri Nov  2 19:23:21 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: flud.h,v 1.4 2000/10/06 03:00:56 lusky Exp $ 
+ * $Id: flud.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $ 
  */
 #ifndef INCLUDED_flud_h
 #define INCLUDED_flud_h
diff -uNrd ircd-hybrid-6.0/include/hash.h ircd-pi1.0a/include/hash.h
--- ircd-hybrid-6.0/include/hash.h	Sun Aug  1 02:47:15 1999
+++ ircd-pi1.0a/include/hash.h	Fri Nov  2 19:23:21 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: hash.h,v 1.8 1999/08/01 06:47:15 tomh Exp $
+ *   $Id: hash.h,v 1.1.1.1 2001/11/03 00:23:21 shifty Exp $
  */
 #ifndef INCLUDED_hash_h
 #define INCLUDED_hash_h
diff -uNrd ircd-hybrid-6.0/include/irc_string.h ircd-pi1.0a/include/irc_string.h
--- ircd-hybrid-6.0/include/irc_string.h	Fri Sep  1 23:42:08 2000
+++ ircd-pi1.0a/include/irc_string.h	Fri May 10 21:30:42 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: irc_string.h,v 1.15 2000/09/02 03:42:08 lusky Exp $
+ *   $Id: irc_string.h,v 1.2 2002/05/11 01:30:42 smoli Exp $
  */
 #ifndef INCLUDED_irc_string_h
 #define INCLUDED_irc_string_h
@@ -40,6 +40,10 @@
  */
 extern char* collapse(char *pattern);
 /*
+ * irclen - lenght of string s
+ */
+extern size_t irclen(const char *s);
+/*
  * irccmp - case insensitive comparison of s1 and s2
  */
 extern int irccmp(const char *s1, const char *s2);
@@ -141,5 +145,8 @@
 
 #define IsNonEOS(c) (CharAttrs[(unsigned char)(c)] & NONEOS_C)
 #define IsEol(c) (CharAttrs[(unsigned char)(c)] & EOL_C)
+
+#define to_upper(c) ((unsigned char)(c) >= (unsigned char)'a'  && (unsigned char)(c) <= (unsigned char)'z') || \
+                    ((unsigned char)(c) >= (unsigned char)'à' && (unsigned char)(c) < (unsigned char)'ÿ') ? ((c) - 0x20) : (c)
 
 #endif /* INCLUDED_irc_string_h */
diff -uNrd ircd-hybrid-6.0/include/ircd.h ircd-pi1.0a/include/ircd.h
--- ircd-hybrid-6.0/include/ircd.h	Sat Dec 30 19:11:55 2000
+++ ircd-pi1.0a/include/ircd.h	Fri May 10 01:32:24 2002
@@ -19,7 +19,7 @@
  *
  * "ircd.h". - Headers file.
  *
- * $Id: ircd.h,v 1.18 2000/12/31 00:11:55 lusky Exp $
+ * $Id: ircd.h,v 1.2 2002/05/10 05:32:24 smoli Exp $
  *
  */
 #ifndef INCLUDED_ircd_h
@@ -75,10 +75,18 @@
   int     chan;           /* Channels */
   int     local;          /* Local Clients */
   int     total;          /* total clients */
+#ifdef HAVE_SSL
+  int     local_ssl;      /* local SSL clients */
+  int     reach_ssl;      /* reachable SSL clients */
+#endif
   int     invisi;         /* invisible clients */
   int     unknown;        /* unknown connections */
   int     max_loc;        /* MAX local clients */
   int     max_tot;        /* MAX global clients */
+#ifdef HAVE_SSL
+  int     max_loc_ssl;    /* MAX local SSL clients */
+  int     max_rch_ssl;    /* MAX reachable SSL clients */
+#endif
   unsigned long totalrestartcount;   /* Total clients since restart */
 };
 
@@ -133,11 +141,15 @@
 extern time_t         LCF;
 extern time_t         nextconnect;
 extern time_t         nextping;
-
-
 extern struct Client* local_cptr_list;
 extern struct Client* oper_cptr_list;
 extern struct Client* serv_cptr_list;
+
+#ifdef BACKUP
+extern int    backup_mode;
+extern int    main_retry;
+extern int    backup_retry;
+#endif /* BACKUP */
 
 #ifdef REJECT_HOLD
 extern int reject_held_fds;
diff -uNrd ircd-hybrid-6.0/include/ircd_defs.h ircd-pi1.0a/include/ircd_defs.h
--- ircd-hybrid-6.0/include/ircd_defs.h	Thu Jul 22 02:33:26 1999
+++ ircd-pi1.0a/include/ircd_defs.h	Fri Nov  2 19:23:22 2001
@@ -17,7 +17,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: ircd_defs.h,v 1.7 1999/07/22 06:33:26 tomh Exp $
+ * $Id: ircd_defs.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  *
  * ircd_defs.h - Global size definitions for record entries used
  * througout ircd. Please think 3 times before adding anything to this
@@ -35,14 +35,14 @@
 #define HOSTLEN         63      /* Length of hostname.  Updated to         */
                                 /* comply with RFC1123                     */
 
-#define NICKLEN         9       /* Necessary to put 9 here instead of 10
+#define NICKLEN         30      /* Necessary to put 9 here instead of 10
                                  * if s_msg.c/m_nick has been corrected.
                                  * This preserves compatibility with old
                                  * servers --msa
                                  */
 #define USERLEN         10
 #define REALLEN         50
-#define TOPICLEN        120     /* old value 90, truncated on other servers */
+#define TOPICLEN        240     /* old value 90, truncated on other servers */
 #define KILLLEN         90      
 #define CHANNELLEN      200
 #define KEYLEN          23
diff -uNrd ircd-hybrid-6.0/include/ircd_signal.h ircd-pi1.0a/include/ircd_signal.h
--- ircd-hybrid-6.0/include/ircd_signal.h	Fri Jul 23 01:05:31 1999
+++ ircd-pi1.0a/include/ircd_signal.h	Fri Nov  2 19:23:22 2001
@@ -17,7 +17,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: ircd_signal.h,v 1.1 1999/07/23 05:05:31 tomh Exp $
+ * $Id: ircd_signal.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  *
  */
 #ifndef INCLUDED_ircd_signal_h
diff -uNrd ircd-hybrid-6.0/include/list.h ircd-pi1.0a/include/list.h
--- ircd-hybrid-6.0/include/list.h	Tue Jul 27 22:42:12 1999
+++ ircd-pi1.0a/include/list.h	Fri Nov  2 19:23:22 2001
@@ -20,7 +20,7 @@
  * "list.h". - Headers file.
  *
  *
- * $Id: list.h,v 1.4 1999/07/28 02:42:12 db Exp $
+ * $Id: list.h,v 1.1.1.1 2001/11/03 00:23:22 shifty Exp $
  *
  */
 
diff -uNrd ircd-hybrid-6.0/include/listener.h ircd-pi1.0a/include/listener.h
--- ircd-hybrid-6.0/include/listener.h	Thu Jul 29 03:06:47 1999
+++ ircd-pi1.0a/include/listener.h	Tue May 21 22:14:28 2002
@@ -16,7 +16,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- * $Id: listener.h,v 1.4 1999/07/29 07:06:47 tomh Exp $
+ * $Id: listener.h,v 1.5 2002/05/22 02:14:28 smoli Exp $
  */
 #ifndef INCLUDED_listener_h
 #define INCLUDED_listener_h
@@ -31,6 +31,7 @@
 #ifndef INCLUDED_ircd_defs_h
 #include "ircd_defs.h"       /* HOSTLEN */
 #endif
+#include "config.h"
 
 struct Client;
 
@@ -45,12 +46,19 @@
   time_t           last_accept;        /* last time listener accepted */
   struct in_addr   addr;               /* virtual address or INADDR_ANY */
   char             vhost[HOSTLEN + 1]; /* virtual name of listener */
+#ifdef HAVE_SSL
+  int              is_ssl;             /* is an SSL listener */
+#endif
 };
 
 extern struct Listener* ListenerPollList; /* GLOBAL - listener list */
 
 extern void        accept_connection(struct Listener* listener);
-extern void        add_listener(int port, const char* vaddr_ip);
+#ifdef HAVE_SSL
+extern int         add_listener(int port, const char* vaddr_ip, int is_ssl);
+#else
+extern int         add_listener(int port, const char* vaddr_ip);
+#endif
 extern void        close_listener(struct Listener* listener);
 extern void        close_listeners(void);
 extern const char* get_listener_name(const struct Listener* listener);
